/*
 * FASt Term Recognizer
 *
 *  FASTR/al-graph.h
 *  Version 2.04/04-02-01
 *
 *  Copyright (C) 2004  Christian Jacquemin, LIMSI-CNRS
 *
 *  This file contains constants about the display
 */

/***************** MAC NON GRAPHIQUE ********************/
#ifdef MACNONGRAPH

#define _MachineGraphique _False

#define _AllerXY(_x,_y)                     { cgotoxy(_x,_y,stdout); }
#define _DialErreur(_x,_y,_z)
#define _DialogueReponseTernaire(_x,_y)      _Oui
#define _DialogueLireChaine(_x,_y,_z,_t,_u)  _Oui
#define _TitresDialogueInfo(_x,_y,_z)
#define _EcritItemInfo(_x,_y)
#define _Alerte(_x,_y)
#define _DialErreurCompil(_x,_y)
#define _EcranGraphique()
#define _FinEcranGraphique()
#define _EffaceEcranGraphique()

typedef Point            UnPoint;
typedef Rect             UnRect;

#define _Random()  ((unsigned int)Random() + 32767)
#define _Fini()

#define _LargeurEcran  600
#define _HauteurEcran  400

#define _GlobalALocal(_ptPt)  GlobalToLocal(_ptPt)
#define _TacheSysteme()  SystemTask()

#define _DefinirRectangle(_ptRe,_l,_t,_r,_b)\
    SetRect(_ptRe,_l,_t,_r,_b)
#define _DeplacerRectangle(_ptRe,_dh,_dv)\
    OffsetRect(_ptRe,_dh,_dv)
#define _TracerRectangle(_ptRe)
#define _PeindreRectangle(_ptRe)
#define _ReductionRectangle(_ptRe,_dh,_dv)  InsetRect(_ptRe,_dh,_dv)
#define _HautRectangle(_re)  _re.top
#define _BasRectangle(_re)  _re.bottom
#define _PointDansRectangle(_point,_ptRe)  PtInRect(_point,_ptRe)

#define _Ligne(_h1,_v1,_h2,_v2)
#define _DessineChaine(_h,_v,_ch)
#define _Blanc  white
#define _Noir  black
#define _Gris  gray
#define _GrisClair  ltGray
#define _GrisFonce  dkGray
#define _CouleurCrayon(_couleur)
#define _CouleurFond(_couleur)
#define _EffaceRectangle(_ptRe)
#define _TailleCrayon(_taille)
#define _CrayonNormal()

#define _SourceXOR  srcXor
#define _CaractTexte(_taille,_style,_mode)

#define _CleCommande  cmdKey
#define _CleMajuscule  shiftKey
#define _CleOption  optionKey
#define _CleEvenement(_ptEvt,_cle)
#define _VideToutEvenement()
#define _EvenementDisponible(_ptEvt)      _False
#define _ExtraireToutEvenement(_ptEvt)
#define _EvtClick(_ptEvt)                 _False
#define _ExtraireProchainClick(_ptEvt)
#define _AttendClick()
#endif

/***************** MAC GRAPHIQUE ********************/
#ifdef MACGRAPH

#define _MachineGraphique _True

void Gprintf( char *p_chaine );

#define printf(c)                            Gprintf(c)
#define _AllerXY(_x,_y)
#define _DialErreur(_x,_y,_z)                DialErreur(_x,_y,_z)
#define _DialogueReponseTernaire(_x,_y)      DialogueReponseTernaire(_x,_y)
#define _DialogueLireChaine(_x,_y,_z,_t,_u)  DialogueLireChaine(_x,_y,_z,_t,_u)
#define _TitresDialogueInfo(_x,_y,_z)        TitresDialogueInfo(_x,_y,_z)
#define _EcritItemInfo(_x,_y)                {CtoPstr(_y);EcritItemInfo(_x,_y);}
#define _Alerte(_x,_y)                       Alerte(_x,_y)
#define _DialErreurCompil(_x,_y)             DialErreurCompil(_x,_y)
#define _EcranGraphique()                    EcranGraphique()
#define _FinEcranGraphique()                 FinEcranGraphique()
#define _EffaceEcranGraphique()              EffaceEcranGraphique()

typedef Point            UnPoint;
typedef Rect             UnRect;
typedef EventRecord      UnEvenement;
typedef WindowPtr        PtUneFenetre;

#define _Random()  ((unsigned int)Random() + 32767)
#define _Fini()

#define _LargeurEcran\
    (screenBits.bounds.right - screenBits.bounds.left)
#define _HauteurEcran\
    (screenBits.bounds.bottom - screenBits.bounds.top)

#define _GlobalALocal(_ptPt)  GlobalToLocal(_ptPt)
#define _TacheSysteme()  SystemTask()

#define _DefinirRectangle(_ptRe,_l,_t,_r,_b)\
    SetRect(_ptRe,_l,_t,_r,_b)
#define _DeplacerRectangle(_ptRe,_dh,_dv)\
    OffsetRect(_ptRe,_dh,_dv)
#define _TracerRectangle(_ptRe)  FrameRect(_ptRe)
#define _PeindreRectangle(_ptRe)  PaintRect(_ptRe)
#define _ReductionRectangle(_ptRe,_dh,_dv)  InsetRect(_ptRe,_dh,_dv)
#define _HautRectangle(_re)  _re.top
#define _BasRectangle(_re)  _re.bottom
#define _PointDansRectangle(_point,_ptRe)  PtInRect(_point,_ptRe)

#define _NouvelleFenetre(_ptFe,_ptRe)\
    _ptFe = NewWindow(NULL,_ptRe,"",true,1,NULL,true,0L)
#define _SelectionFenetre(_ptFe)\
    SelectWindow(_ptFe);\
    SetPort(_ptFe)
#define _ClickDansFenetre(_ptEvt,_point,_ptFe)\
    (FindWindow(_point,&_ptFe) == inContent)
#define _RendFenetre(_ptFe)\
    DisposeWindow(_ptFe)

#define _Ligne(_h1,_v1,_h2,_v2)\
    MoveTo(_h1,_v1);LineTo(_h2,_v2)
#define _DessineChaine(_h,_v,_ch)\
    MoveTo(_h,_v);CtoPstr(_ch);DrawString(_ch)
#define _Blanc  white
#define _Noir  black
#define _Gris  gray
#define _GrisClair  ltGray
#define _GrisFonce  dkGray
#define _CouleurCrayon(_couleur)   PenPat(_couleur)
#define _CouleurFond(_couleur)     PenPat(_couleur)
#define _EffaceRectangle(_ptRe)\
    {\
       _CouleurCrayon(_Blanc);\
       _PeindreRectangle(_ptRe);\
       _CouleurCrayon(_Noir);\
    }
#define _TailleCrayon(_taille)  PenSize(_taille,_taille)
#define _CrayonNormal()         PenSize(1,1);PenPat(black);PenMode(patCopy)

#define _SourceXOR  srcXor
#define _CaractTexte(_taille,_style,_mode)\
    TextFont(2);\
    TextSize(_taille);TextFace(_style);TextMode(_mode)

#define _CleCommande  cmdKey
#define _CleMajuscule  shiftKey
#define _CleOption  optionKey
#define _LieuEvenement(_ptEvt,_ptPt)       *(_ptPt) = (_ptEvt)->where
#define _CleEvenement(_ptEvt,_cle)         (_ptEvt->modifiers & _cle)
#define _VideToutEvenement()               FlushEvents(everyEvent,0);
#define _EvenementDisponible(_ptEvt)\
    (EventAvail(everyEvent,_ptEvt) && _ptEvt)
#define _ExtraireToutEvenement(_ptEvt)\
    GetNextEvent(everyEvent,_ptEvt)
#define _EvtClick(_ptEvt)  ((_ptEvt)->what == mouseDown)
#define _ExtraireProchainClick(_ptEvt)\
    for( ; ; )\
    { GetNextEvent(everyEvent ,_ptEvt);\
      if( (_ptEvt)->what == mouseDown )\
          break;\
      else\
          SystemTask();\
    }
#define _AttendClick()\
    {EventRecord _evt;\
        for( ; ; )\
        {\
             GetNextEvent( everyEvent , &_evt );\
             SystemTask();\
             if( _evt.what == mouseDown )\
                  break;\
        }\
    }
#endif

/***************** DEC ********************/
#ifdef DEC

#define _MachineGraphique  (DisplayCourant && ModeInteractif)

#define  _FinLigne 1
typedef struct
    {
    short    v,h;
    }                     UnPoint;
typedef struct
    {
    short    top,left,bottom,right ;
    }                     UnRect;
typedef XEvent            UnEvenement;
typedef Window            PtUneFenetre;

#define float double
#define _AllerXY(_x,_y) \
    {\
          printf("%c[%d;%dH",27,_x,_y);\
    }
#define _DialErreur(_x,_y,_z)
#define _DialogueReponseTernaire(_x,_y)      _Oui
#define _DialogueLireChaine(_x,_y,_z,_t,_u)  _Oui
#define _TitresDialogueInfo(_x,_y,_z)
#define _EcritItemInfo(_x,_y)
#define _Alerte(_x,_y)
#define _DialErreurCompil(_x,_y)
#define _EcranGraphique()
#define _FinEcranGraphique()
#define _EffaceEcranGraphique()

#define _Random()  ((double)rand()/pow(2,15))

#define _Fini()\
    {\
       if(DisplayCourant)\
       {\
          XCloseDisplay(DisplayCourant);\
       }\
       sys$exit(1);\
    }


#define _LargeurEcran  XWidthOfScreen(EcranCourant)
#define _HauteurEcran  XHeightOfScreen(EcranCourant)

#define _CleCommande  ControlMask
#define _CleMajuscule  ShiftMask
#define _CleOption  LockMask

#define _GlobalALocal(_ptPt)  ;
#define _TacheSysteme()  ;

#define _DefinirRectangle(_ptRe,_l,_t,_r,_b)\
    (_ptRe)->left = _l;(_ptRe)->top = _t;(_ptRe)->right = _r;(_ptRe)->bottom = _b
#define _DeplacerRectangle(_ptRe,_dh,_dv)\
    (_ptRe)->left += _dh;(_ptRe)->top += _dv;(_ptRe)->right += _dh;(_ptRe)->bottom += _dv
#define _ReductionRectangle(_ptRe,_dh,_dv)\
    (_ptRe)->left += _dh;(_ptRe)->top += _dv;(_ptRe)->right -= _dh;(_ptRe)->bottom -= _dv
#define _HautRectangle(_re)   _re.top
#define _BasRectangle(_re)   _re.bottom
#define _PointDansRectangle(_point,_ptRe)\
    (   _point.v >= (_ptRe)->top && _point.v <= (_ptRe)->bottom \
     && _point.h >= (_ptRe)->left && _point.h <= (_ptRe)->right )

#define _Blanc  1
#define _Noir  2
#define _Gris  3
#define _GrisClair  4
#define _GrisFonce  5
#define _CouleurCrayon(_couleur)\
    {\
       XGCValues       xgcv;\
       xgcv.foreground = doDefineColor(_couleur);\
       XChangeGC( DisplayCourant , ContexteGraphiqueCourant , \
                  GCForeground , &xgcv );\
    }
#define _CouleurFond(_couleur)\
    {\
       XGCValues       xgcv;\
       xgcv.background = doDefineColor(_couleur);\
       XChangeGC( DisplayCourant , ContexteGraphiqueCourant , \
                  GCBackground , &xgcv );\
    }
#define _EffaceRectangle(_ptRe) _CouleurFond(_Blanc)
#define _TailleCrayon(_taille)\
    {\
       XGCValues       xgcv;\
       xgcv.line_width = _taille;\
       XChangeGC( DisplayCourant , ContexteGraphiqueCourant , \
                  GCLineWidth , &xgcv );\
    }
#define _ModeCrayon(_mode)\
    {\
       XGCValues       xgcv;\
       xgcv.function = _mode;\
       XChangeGC( DisplayCourant , ContexteGraphiqueCourant , \
                  GCFunction , &xgcv );\
    }
#define _CrayonNormal()\
    {\
       XGCValues       xgcv;\
       _CouleurCrayon(_Noir);\
       xgcv.line_width = 1;\
       xgcv.function = GXcopy;\
       XChangeGC( DisplayCourant , ContexteGraphiqueCourant , \
                  GCLineWidth | GCFunction , &xgcv );\
    }
#define _NouvelleFenetre(_ptFe,_ptRe)\
    {\
      XSetWindowAttributes      xswa;\
      XGCValues                 xgcv;\
      xswa.event_mask = ExposureMask | ButtonPressMask;\
      xswa.background_pixel = doDefineColor(_Blanc);\
      _ptFe = XCreateWindow( \
               DisplayCourant , XRootWindowOfScreen(EcranCourant) ,\
               (_ptRe)->left , (_ptRe)->top , (_ptRe)->right - (_ptRe)->left , \
               (_ptRe)->bottom - (_ptRe)->top , 0 , \
               XDefaultDepthOfScreen(EcranCourant) , InputOutput , \
               XDefaultVisualOfScreen(EcranCourant) , \
               CWEventMask | CWBackPixel , \
               &xswa );\
      xgcv.foreground = doDefineColor(_Noir);\
      xgcv.background = doDefineColor(_Noir);\
      xgcv.line_style = LineSolid;\
      xgcv.line_width = 1;\
      xgcv.function = GXcopy;\
      ContexteGraphiqueCourant = XCreateGC( DisplayCourant , _ptFe , \
               GCForeground | GCBackground | GCLineStyle | GCLineWidth \
             | GCFunction , &xgcv );\
    }
#define _SelectionFenetre(_ptFe)\
    XMapWindow( DisplayCourant , _ptFe )
#define _ClickDansFenetre(_ptEvt,_point,_ptFe)\
    ((_ptEvt)->xany.window == FenCour)
#define _RendFenetre(_ptFe)\
    XUnmapWindow( DisplayCourant , _ptFe );\
    XDestroyWindow( DisplayCourant , _ptFe )

#define _Ligne(_h1,_v1,_h2,_v2)\
    XDrawLine( DisplayCourant , FenCour , \
               ContexteGraphiqueCourant , _h1 , _v1 , _h2 , _v2 )
#define _DessineChaine(_h,_v,_ch)\
    XDrawImageString(DisplayCourant,FenCour,\
                     ContexteGraphiqueCourant , _h , _v , _ch , strlen(_ch) )
#define _TracerRectangle(_ptRe)\
    XDrawRectangle(DisplayCourant,FenCour,\
                     ContexteGraphiqueCourant,(_ptRe)->left , (_ptRe)->top,\
                     (_ptRe)->right - (_ptRe)->left,\
                     (_ptRe)->bottom - (_ptRe)->top);
#define _PeindreRectangle(_ptRe)\
    XFillRectangle( DisplayCourant , FenCour , \
                ContexteGraphiqueCourant , (_ptRe)->left , (_ptRe)->top , \
                (_ptRe)->right - (_ptRe)->left , \
                (_ptRe)->bottom - (_ptRe)->top )

#define _SourceXOR  GXxor
#define _CaractTexte(_taille,_style,_mode)\
    {\
      Font           font;\
      font = XLoadFont( DisplayCourant , \
                "-ADOBE-NEW CENTURY SCHOOLBOOK-MEDIUM-R-NORMAL--*-140-*-*-P-*") ;\
      XSetFont( DisplayCourant , ContexteGraphiqueCourant , font );\
    }

#define _LieuEvenement(_ptEvt,_ptPt)\
    (_ptPt)->h = ((XButtonEvent *)(_ptEvt))->x;\
    (_ptPt)->v = ((XButtonEvent *)(_ptEvt))->y
#define _CleEvenement(_ptEvt,_cle)\
    (((XKeyEvent *)(_ptEvt))->state & _cle)
#define _VideToutEvenement()\
    if( !_MachineGraphique )\
    {\
         fflush( stdin );\
    }
#define _EvenementDisponible(_ptEvt)  (XPending(DisplayCourant) > 0)
#define _ExtraireToutEvenement(_ptEvt)  XNextEvent(DisplayCourant,_ptEvt)
#define _EvtClick(_ptEvt)  ((_ptEvt)->type == ButtonPress)
#define _ExtraireProchainClick(_ptEvt)\
    for( ; ; )\
    {\
         XNextEvent(DisplayCourant,_ptEvt);\
         if( (_ptEvt)->type == ButtonPress )\
              break;\
    }
#define _AttendClick()\
    {XEvent _evt;\
        for( ; ; )\
        {\
             XNextEvent(DisplayCourant,&_evt);\
             if( _evt.type == ButtonPress )\
                  break;\
        }\
    }
#endif

/***************** SUN ********************/
#ifdef SUN

#define _MachineGraphique  _False
/* (DisplayCourant && ModeInteractif) */

typedef struct
    {
    short    v,h;
    }                     UnPoint;
typedef struct
    {
    short    top,left,bottom,right ;
    }                     UnRect;
#define float double

#define _AllerXY(_x,_y) \
    {\
          printf("%c[%d;%dH",27,_y,_x);\
    }
#define _DialErreur(_x,_y,_z)
#define _DialogueReponseTernaire(_x,_y)      _Oui
#define _DialogueLireChaine(_x,_y,_z,_t,_u)  _Oui
#define _NouveauDialogueInfo(_x,_y)
#define _TitresDialogueInfo(_x,_y,_z)
#define _EcritItemInfo(_x,_y)
#define _Alerte(_x,_y)
#define _DialErreurCompil(_x,_y)
#define _EcranGraphique()
#define _FinEcranGraphique()
#define _EffaceEcranGraphique()

#define _Random()  ((double)rand()/pow(2,15))

#define _LargeurEcran  500
/* XWidthOfScreen(EcranCourant) */
#define _HauteurEcran  500
/* XHeightOfScreen(EcranCourant) */

#define _Ligne(_h1,_v1,_h2,_v2)
#define _DessineChaine(_h,_v,_ch)
#define _Blanc  0
#define _Noir  0
#define _Gris  0
#define _GrisClair  0
#define _GrisFonce  0
#define _CouleurCrayon(_couleur)
#define _CouleurFond(_couleur)
#define _EffaceRectangle(_ptRe)
#define _TailleCrayon(_taille)
#define _CrayonNormal()

#define _SourceXOR  0
#define _CaractTexte(_taille,_style,_mode)

#define _CleCommande  0
#define _CleMajuscule  0
#define _CleOption  0
#define _CleEvenement(_ptEvt,_cle)
#define _VideToutEvenement()
#define _EvenementDisponible(_ptEvt)      _False
#define _ExtraireToutEvenement(_ptEvt)
#define _EvtClick(_ptEvt)                 _False
#define _ExtraireProchainClick(_ptEvt)
#define _AttendClick()
#define _DefinirRectangle(_ptRe,_l,_t,_r,_b)\
    (_ptRe)->left = _l;(_ptRe)->top = _t;(_ptRe)->right = _r;(_ptRe)->bottom = _b
#define _TracerRectangle(_ptRe)
#endif

#ifdef MAC
/* Gchaines.c                                                          */
void EffaceFenetreTexte( void );
void ChaineRsrc( int p_indRsrc , int p_indCh , char *p_ch );

/* Gdialogues.c                                                        */
char     ClickDansAnnulerInfo( void );
void     NouveauDialogueInfo( int p_noDialogue , char p_avecAnnuler );
void     FinDialogueInfo( void );
char     DialogueReponseTernaire( int p_indTitre , char p_estBinaireSeule );
char     DialogueLireChaine( int p_indTitre , int p_indTitreDemande ,
                             char *p_uneChaine , int p_longMax , int p_noDialogue );
void     TitresDialogueInfo( int p_indTitre , int p_indNomCommentaire1,
                             int p_indNomCommentaire2 );
void     EcritItemInfo( int p_noItem , char *p_chaine );

/* Gfenetres.c                                                         */
void     EcranGraphique( void );
void     FinEcranGraphique( void );
void     EffaceEcranGraphique( void );
void     EnTete( char p_dureeLimitee );

/* Gfichiers.c                                                         */
void ChargeFichierDicoSelectionne( void );

/* GMac.c                                                              */
void DialErreur( int p_noErreur , char *p_texte , char *p_chaineResource );
void Alerte( int p_indTexte , int p_noIcon );
void DialErreurCompil( char *p_texte1 , char *p_texte2 );

/* Gppal.c                                                             */
void InitGraphisme( void );
void BoucleAttenteEvenement( void );

#endif

